//
//  Getting_a_Reference_to_Address_BookAppDelegate.m
//  Getting a Reference to Address Book
//
//  Created by Vandad Nahavandipoor on 21/07/2011.
//  Copyright 2011 Pixolity Ltd. All rights reserved.
//

#import "Getting_a_Reference_to_Address_BookAppDelegate.h"

@implementation Getting_a_Reference_to_Address_BookAppDelegate

@synthesize window = _window;

- (BOOL)            application:(UIApplication *)application
  didFinishLaunchingWithOptions:(NSDictionary *)launchOptions{
  
  ABAddressBookRef addressBook = ABAddressBookCreate();
  
  if (addressBook != nil){
    NSLog(@"Udało się uzyskać dostęp do książki adresowej.");
    
    /* Praca z książką adresową. */
    
    /* Przed próbą zapisu sprawdzamy, czy wprowadzone zostały jakiekolwiek zmiany. */
    
    if (ABAddressBookHasUnsavedChanges(addressBook)){
      /* Podjęcie decyzji o zapisaniu zmian w książce adresowej. */
      NSLog(@"W książce adresowej wprowadzono pewne zmiany.");
      
      BOOL doYouWantToSaveChanges = YES;
      
      /* Można zapisać zmiany lub je odrzucić i pozostawić książkę adresową w stanie sprzed wprowadzenia zmian. */
      if (doYouWantToSaveChanges){
        
        CFErrorRef saveError = NULL;
        
        if (ABAddressBookSave(addressBook, &saveError)){
          /* Udało się wprowadzić zmiany w książce adresowej. */
        } else {
          /* Nie udało się wprowadzić zmiany w książce adresowej.
               Informacje o błędzie znajdziesz w zmiennej [saveError]. */
        }
        
      } else {
        
        /* NIE chcemy zapisywać zmian w książce adresowej.
            Przywracamy ją do stanu sprzed wprowadzenia zmian. */
        ABAddressBookRevert(addressBook);
        
      }
      
    } else {
      /* Nie wprowadzono żadnych zmian w książce adresowej. */
      NSLog(@"Nie wprowadzono żadnych zmian w książce adresowej.");
    }
    
    CFRelease(addressBook);
    
  } else {
    NSLog(@"Nie można uzyskać dostępu do książki adresowej.");
  }
  
  self.window = [[UIWindow alloc] initWithFrame:
                 [[UIScreen mainScreen] bounds]];
  
  self.window.backgroundColor = [UIColor whiteColor];
  [self.window makeKeyAndVisible];
  return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application
{
  /*
   Ta metoda jest wywoływana, gdy aplikacja przechodzi ze stanu aktywnego do nieaktywnego. Może być wywołana w określonych sytuacjach (na przykład w chwili odbywania rozmowy telefonicznej lub po otrzymaniu wiadomości SMS) bądź kiedy użytkownik kończy działanie aplikacji. Metoda rozpoczyna proces przejścia do stanu pozostania w tle. Tę metodę można wykorzystać do wstrzymania wykonywania bieżących zadań, wyłączenia liczników czasu, zmniejszenia liczby klatek generowanych przez OpenGL ES. W grach ta metoda powinna być użyta do wstrzymania gry (pauza).
   */
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
  /*
   Tę metodę należy wykorzystać do zwolnienia zasobów współdzielonych, zapisania danych użytkownika, wyzerowania liczników czasu oraz do przechowania takiej ilości informacji o stanie, która pozwoli na przywrócenie aplikacji do stanu bieżącego. Jeżeli aplikacja obsługuje działanie w tle, w chwili kończenia działania należy wywołać tę metodę zamiast applicationWillTerminate:.
   */
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
  /*
   Ta metoda jest wywoływana podczas przechodzenia aplikacji ze stanu aktywnego do działania w tle. Można więc tutaj wycofać wiele zmian wprowadzonych w chwili przechodzenia do stanu działania w tle.
   */
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
  /*
   W tej metodzie można wznowić działanie zadań zatrzymanych (lub nieuruchomionych), gdy aplikacja była nieaktywna. Jeżeli aplikacja znajdowała się w trybie działania w tle, w metodzie można przeprowadzić odświeżenie interfejsu użytkownika.
   */
}

- (void)applicationWillTerminate:(UIApplication *)application
{
  /*
   Ta metoda jest wywoływana, gdy działanie aplikacji ma zostać zakończone. Zapoznaj się z opisem metody applicationDidEnterBackground:.
   */
}

@end
